AbstractDeserializer (Jackson JSON Processor)
Date: 2013-07-14

org.codehaus.jackson.map.deser

## Class AbstractDeserializer

- java.lang.Object
- - org.codehaus.jackson.map.JsonDeserializer<Object>
  - - org.codehaus.jackson.map.deser.AbstractDeserializer

-     public class AbstractDeserializer
      extends JsonDeserializer<Object>

  Deserializer only used as placeholder for abstract types during polymorphic type handling deserialization. If so, there is no real deserializer associated with nominal type, just `TypeDeserializer`; and any calls that do not pass such resolver will result in an error.
  Since:
    1.6
  Author:
    tatu

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.codehaus.jackson.map.JsonDeserializer

      `JsonDeserializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected boolean` | `_acceptBoolean`
    `protected boolean` | `_acceptDouble`
    `protected boolean` | `_acceptInt`
    `protected boolean` | `_acceptString`
    `protected JavaType` | `_baseType`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractDeserializer(JavaType bt)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected Object` | `_deserializeIfNatural(JsonParser jp, DeserializationContext ctxt)`
    `Object` | `deserialize(JsonParser jp, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
    `Object` | `deserializeWithType(JsonParser jp, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Deserialization called when type being deserialized is defined to contain additional type identifier, to allow for correctly instantiating correct subtype.

    - ### Methods inherited from class org.codehaus.jackson.map.JsonDeserializer

      `deserialize, getEmptyValue, getNullValue, unwrappingDeserializer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _baseType

          protected final JavaType _baseType

    - #### _acceptString

          protected final boolean _acceptString

    - #### _acceptBoolean

          protected final boolean _acceptBoolean

    - #### _acceptInt

          protected final boolean _acceptInt

    - #### _acceptDouble

          protected final boolean _acceptDouble

  - ### Constructor Detail

    - #### AbstractDeserializer

          public AbstractDeserializer(JavaType bt)

  - ### Method Detail

    - #### deserializeWithType

          public Object deserializeWithType(JsonParser jp,
                                   DeserializationContext ctxt,
                                   TypeDeserializer typeDeserializer)
                                     throws IOException,
                                            JsonProcessingException

      Description copied from class: `JsonDeserializer`
      Deserialization called when type being deserialized is defined to contain additional type identifier, to allow for correctly instantiating correct subtype. This can be due to annotation on type (or its supertype), or due to global settings without annotations.

      Default implementation may work for some types, but ideally subclasses should not rely on current default implementation. Implementation is mostly provided to avoid compilation errors with older code.

      Overrides:
        `deserializeWithType` in class `JsonDeserializer<Object>`
        `typeDeserializer` - Deserializer to use for handling type information
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### deserialize

          public Object deserialize(JsonParser jp,
                           DeserializationContext ctxt)
                             throws IOException,
                                    JsonProcessingException

      Description copied from class: `JsonDeserializer`
      Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

      Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker. Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

      Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

      Specified by:
        `deserialize` in class `JsonDeserializer<Object>`
      Parameters:
        `jp` - Parsed used for reading JSON content
        `ctxt` - Context that can be used to access information about this deserialization activity.
      Returns:
        Deserializer value
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### _deserializeIfNatural

          protected Object _deserializeIfNatural(JsonParser jp,
                                     DeserializationContext ctxt)
                                          throws IOException,
                                                 JsonProcessingException

      Throws:
        `IOException`
        `JsonProcessingException`